<template>
  <div class="block-content">
    <form>
      <div class="form-content">
        <label class="form-label">Region</label>
        <input type="text" class="form-value" id="reg" v-model="region.region"/>
      </div>
      <div class="err" id="reg-err">
        <p style="color: red;">Country name shouldn't contain numbers
          or being empty!
        </p>
      </div>
      <div class="form-content">
        <label class="form-label">Country</label>
        <select class="form-value" id="country" v-model="region.countryId">
          <option selected>---------</option>
          <option v-for="country in countries" :key="country.id" :item="country"
          :value="country.id" v-on:click="this.region.countryId = country.id">
            {{country.country}}
          </option>
        </select>
      </div>
      <div class="err" id="country-err">
        <p style="color: red;">please select one value</p>
      </div>
      <div class="form-content">
        <input type="button" value="Submit and new" class="form-button"
        v-on:click="submit('Region'); this.object = {}" />
        <input type="button" value="Submit" class="form-button"
        id="righter" v-on:click="submit('Regions')" />
      </div>
    </form>
  </div>
</template>

<script>
import axios from 'axios';

export default {
  name: 'Region',
  props: {
    object: Number,
  },
  data() {
    return {
      countries: [],
      region: {},
    };
  },
  mounted() {
    this.getCountry();
    this.get();
  },
  methods: {
    getCountry() {
      axios.get('http://localhost:4000/api/countries').then(
        (result) => {
          this.countries = result.data;
        },
      ).catch((error) => {
        console.log(error);
      });
    },
    get() {
      if (this.object > 0) {
        axios.get(`http://localhost:4000/api/regions/${this.object}`).then(
          (result) => {
            this.region = result.data;
          },
        ).catch((error) => {
          console.log(error);
        });
      }
    },
    validateRegion(obj) {
      const reg = /.*\d.*/;
      if (obj.region && obj.countryId
        && !reg.test(obj.region)) {
        return true;
      }
      if (!obj.region || reg.test(obj.region)) {
        document.getElementById('reg').style.borderColor = 'red';
        document.getElementById('reg-err').style.display = 'block';
      }
      if (!obj.countryId) {
        document.getElementById('country').style.border = 'red';
        document.getElementById('country-err').style.display = 'block';
      }

      return false;
    },
    submit(component) {
      if (this.object === 0) {
        if (this.validateRegion(this.region)) {
          axios.post('http://localhost:4000/api/regions/', {
            region: this.region.region,
            countryId: this.region.countryId,
          })
            .then((response) => { console.log(response); alert('succesfully saved!'); })
            .catch((e) => {
              console.log(e);
            });
        }
        this.nullify();
        this.$emit('change-component', component);
      } else {
        if (this.validateRegion(this.region)) {
          axios.patch(`http://localhost:4000/api/regions/${this.object}`, {
            region: this.region.region,
            countryId: this.region.countryId,
          })
            .then((response) => { console.log(response); alert('succesfully saved!'); })
            .catch((e) => {
              console.log(e);
            });
        }
        this.$emit('change-component', component);
        this.$emit('object', 0);
      }
    },
    nullify() {
      document.getElementById('reg').value = '';
    },
  },
};
</script>

<style scoped>
@import "../CSS/actionObject.css";
</style>
